"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Credits = void 0;
var react_1 = __importStar(require("react"));
var primeobjects_ui_web_basic_1 = require("primeobjects-ui-web-basic");
var primary_color_1 = require("primeobjects-helper-ui/build/cjs/hooks/primary-color");
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var colors_1 = require("primeobjects-helper-util/build/cjs/colors");
var auth_call_api_1 = require("../context/auth-call-api");
var util_1 = require("../util");
var core_2 = require("primeobjects-helper-util/build/cjs/core");
var use_event_1 = require("primeobjects-ui-web-basic/build/cjs/hooks/use-event");
var tooltip_1 = __importDefault(require("../controls/antd/tooltip"));
var Credits = function (props) {
    var _a;
    var solution = props.solution, name = props.name, dollarAreaClassName = props.dollarAreaClassName, wrapperClassName = props.wrapperClassName, creditsAreaClassName = props.creditsAreaClassName;
    var _b = (0, react_1.useState)(-10000), value = _b[0], setValue = _b[1];
    var _c = (0, react_1.useState)(false), error = _c[0], setError = _c[1];
    var label = (_a = props.label) !== null && _a !== void 0 ? _a : "Credits";
    var primaryColor = (0, primary_color_1.getPrimaryColor)(solution);
    var refreshCredits = (0, use_event_1.useEvent)("ai-credit-update-channel")[0];
    var dollarUSD = Math.ceil(value * 0.00001 * 100) / 100;
    var getColor = function (v) {
        if (v == -10000)
            return colors_1.COLORS.GRAY[600];
        if (v > 20000)
            return colors_1.COLORS.GREEN["600"];
        if (v > 5000)
            return colors_1.COLORS.LIME["600"];
        if (v > 500)
            return colors_1.COLORS.ORANGE["600"];
        return colors_1.COLORS.RED["600"];
    };
    var color = getColor(value);
    (0, react_1.useEffect)(function () {
        (0, auth_call_api_1.callApi)(solution, (0, util_1.getApiEndpoint)(solution, "organization", "retrieve-credits"), { name: name }, "GET")
            .then(function (result) {
            setValue(result.balance);
        })
            .catch(function (err) {
            console.error(err);
            setError(true);
        });
    }, [refreshCredits]);
    var renderError = function () {
        if (!error)
            return null;
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { src: "/icons/platform/wallet.svg", size: 20, className: "mr-2" }),
            react_1.default.createElement("div", { className: "text-red-600" }, "Error")));
    };
    var renderLoader = function () {
        if (value != -10000 || error)
            return null;
        return (react_1.default.createElement(primeobjects_ui_web_basic_1.Lottie, { style: { width: 60, height: 30 }, url: "/icons/platform/lottie/dots-2.json", colors: Array(6).fill(primaryColor["500"]) }));
    };
    var renderContent = function () {
        if (value == -10000 || error)
            return null;
        return (react_1.default.createElement("span", { className: "flex flex-row cursor-pointer items-center" },
            react_1.default.createElement("span", { className: "text-sm font-bold px-1 ".concat(creditsAreaClassName !== null && creditsAreaClassName !== void 0 ? creditsAreaClassName : ""), style: { color: color } }, (0, core_1.formatNumberBMK)(value)),
            react_1.default.createElement("span", { className: "text-xs text-gray-600 px-1 ".concat(dollarAreaClassName !== null && dollarAreaClassName !== void 0 ? dollarAreaClassName : "") }, "(USD: $".concat((0, core_2.numberWithCommas)(dollarUSD), ")"))));
    };
    return (react_1.default.createElement("div", { className: "m-4 flex flex-row py-2 px-3".concat(wrapperClassName !== null && wrapperClassName !== void 0 ? wrapperClassName : "") }, !error ? (react_1.default.createElement(tooltip_1.default, { title: react_1.default.createElement("span", null,
            label,
            ": ",
            (0, core_2.numberWithCommas)(value),
            react_1.default.createElement("br", null),
            "USD: $",
            (0, core_2.numberWithCommas)(dollarUSD)), color: color, placement: "bottom" },
        react_1.default.createElement("div", { className: "flex self-center items-center" },
            react_1.default.createElement(primeobjects_ui_web_basic_1.SVG, { src: "/icons/platform/wallet.svg", size: 20, className: "mr-2" }),
            renderContent(),
            renderLoader()))) : (renderError())));
};
exports.Credits = Credits;
exports.default = exports.Credits;
//# sourceMappingURL=credits.js.map