import React, { CSSProperties } from "react";
export type TAIStramApiType = "prompt" | "message";
export type TAIStreamRequest = {
    id: string;
    apiType: TAIStramApiType;
    start?: number;
    parameters?: Record<string, string>[];
    template: string;
    maxTokens?: number;
    temperature?: number;
    model?: string;
    bestOf?: number;
    transactionId?: string;
};
export type TAIStreamProps = {
    solution?: Record<string, any>;
    request?: TAIStreamRequest;
    start?: number;
    placeholder?: string;
    onStart?: () => void;
    onData?: (text?: string) => void;
    onError?: (error: any) => void;
    onChange?: (text: string) => void;
    onFinish?: (value: string) => void;
    style?: CSSProperties;
    className?: string;
    rows?: number | undefined;
    maxRows?: number | undefined;
    disabled?: boolean;
};
export declare const AIStream: (props: TAIStreamProps) => React.JSX.Element;
export default AIStream;
