import React, { CSSProperties } from "react";
import { TListResult } from "./table";
import { TListColumn } from "./util";
export type TListQueryScope = "organization" | "membership";
export type TListQuery = {
    name: string;
    keywords?: string;
    tags?: string[];
    nodes?: Record<string, any>[];
    conditions?: Record<string, any>[];
    pageNumber?: number;
    scope?: TListQueryScope;
    query?: Record<string, any>;
    recordForMembership?: Record<string, any>;
};
export type TOnClickRecordResult = {
    actionName: string;
    actionData?: Record<string, any> | string | number;
};
export type TListSectionProps = {
    defaultRecordId?: string;
    wrapperClassName?: string;
    wrapperStyle?: CSSProperties;
    tableWrapperStyle?: CSSProperties;
    tableWrapperClassName?: string;
    apis?: Record<string, any>;
    query: {
        entityName: string;
        entityType?: string;
    } & Record<string, any>;
    refresh?: string;
    tags?: string[];
    nodes?: Record<string, any>[];
    conditions?: Record<string, any>[];
    hideHeader?: boolean;
    currentRecord?: Record<string, any>;
    recordToUpdate?: Record<string, any>;
    recordToDelete?: Record<string, any>;
    recordDeleted?: Record<string, any>;
    recordForMembership?: Record<string, any>;
    minWidth?: number;
    showScrollbarX?: boolean;
    resetUI?: number | string | undefined;
    getColumns?: (onClick: (record: Record<string, any>, action?: string, entity?: Record<string, any>, rowIndex?: number) => void, entity?: Record<string, any>) => TListColumn[];
    onReadRecord?: (record: Record<string, any>, action?: string, entity?: Record<string, any>, rowIndex?: number) => Record<string, any> | undefined;
    onEditRecord?: (record: Record<string, any>, action?: string, entity?: Record<string, any>, rowIndex?: number) => Record<string, any> | undefined;
    onClickRecord?: (record: Record<string, any>, action?: string, entity?: Record<string, any>, rowIndex?: number) => TOnClickRecordResult[] | undefined;
    onStartAction?: (record: Record<string, any>, action?: string, entity?: Record<string, any>, rowIndex?: number) => void;
    onRunningAction?: (record: Record<string, any>, action?: string, entity?: Record<string, any>, rowIndex?: number) => void;
    onFinishAction?: (record: Record<string, any>, action?: string, entity?: Record<string, any>, rowIndex?: number) => void;
    onErrorAction?: (record: Record<string, any>, action?: string, entity?: Record<string, any>, rowIndex?: number) => void;
    onRemoveFilter?: (filter?: Record<string, any>, newData?: Record<string, any>[]) => void;
    onCreateRecord?: (record: Record<string, any>) => Record<string, any> | undefined;
    onCreateRecordInline?: (record: Record<string, any>) => Promise<Record<string, any> | undefined>;
    renderCategories?: (onClose?: () => void) => any;
    onClickCategories?: () => void;
    onCloneRecord?: (record: Record<string, any>) => void;
    onDeleteRecord?: (record: Record<string, any>) => void;
    onLoadPostProcess?: (query: Record<string, any>, result: TListResult) => Promise<TListResult>;
    onLoadSuccess?: (query: Record<string, any>, result: TListResult) => void;
    onLoadFailed?: (query: Record<string, any>, error: any) => void;
    manualLoadMore?: boolean;
    hideSearch?: boolean;
    hideSearchService?: boolean;
    showFilterButton?: boolean;
    showToggleTagsButton?: boolean;
    hideRefreshButton?: boolean;
    hideCreateButton?: boolean;
    hideExportButton?: boolean;
    exportProps?: string[];
    hideCategoriesButton?: boolean;
    hideEntityIcon?: boolean;
    hideFilterSection?: boolean;
    createButtonText?: string;
    children?: any;
    infoHeaderContent?: any;
    hideInfoHeader?: boolean;
    infoFooterContent?: any;
    hideInfoFooter?: boolean;
};
export declare const ListSection: (props: TListSectionProps) => React.JSX.Element;
export default ListSection;
