"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MeNavItem = void 0;
var react_1 = __importDefault(require("react"));
var mobx_react_lite_1 = require("mobx-react-lite");
var primeobjects_ui_web_store_1 = require("primeobjects-ui-web-store");
var avatar_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/avatar"));
exports.MeNavItem = (0, mobx_react_lite_1.observer)(function (props) {
    var contextStore = (0, primeobjects_ui_web_store_1.useContextStore)();
    var context = JSON.parse(contextStore.data);
    var user = context.user;
    // const realtimeNetworkConnected = useCurrentRealtimeNetwork();
    // useEffect(() => {
    //     if (realtimeNetworkConnected) {
    //         context.user.currentStatus = "on";
    //         contextStore.setData(context);
    //     }
    // }, [realtimeNetworkConnected]);
    var menuItems = props.menuItems ? props.menuItems : [];
    if (props.onClickSignOut)
        menuItems.unshift({
            title: "Sign Out",
            onClick: function () {
                if (props.onClickSignOut)
                    props.onClickSignOut(user);
            }
        });
    if (props.onClickUserProfile)
        menuItems.unshift({
            title: "Your Profile",
            onClick: function () {
                if (props.onClickUserProfile)
                    props.onClickUserProfile(user);
            }
        });
    return (react_1.default.createElement(avatar_1.default, __assign({}, props, { menuItems: menuItems, data: user, onClick: props.onClick })));
});
exports.default = exports.MeNavItem;
//# sourceMappingURL=me.js.map