"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteFooterSection = void 0;
var react_1 = __importDefault(require("react"));
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
var SiteFooterSection = function (props) {
    var copyright = props.copyright, businessName = props.businessName, className = props.className, style = props.style, content = props.content;
    var colorName = (0, primeobjects_helper_ui_1.usePrimaryColorName)();
    var year = new Date().getFullYear();
    var copyrightContent = copyright;
    if ((0, primeobjects_helper_util_1.isNonEmptyString)(copyrightContent))
        copyrightContent = copyrightContent.replace(/\[PH.YEAR\]/g, "".concat(year));
    if ((0, primeobjects_helper_util_1.isNonEmptyString)(copyrightContent) && (0, primeobjects_helper_util_1.isNonEmptyString)(businessName))
        copyrightContent = copyrightContent.replace(/\[PH.BUSINESSNAME\]/g, "".concat(businessName));
    return (react_1.default.createElement("footer", { className: "sticky mt-6 flex flex-col md:flex-row top-[100vh] max-w-7xl w-full py-6 mx-auto px-6 sm:px-8 lg:px-10 border-t border-".concat(colorName, "-200 ").concat(className ? className : ""), style: __assign({}, style) },
        react_1.default.createElement("div", { className: "flex-1", dangerouslySetInnerHTML: { __html: content } }),
        react_1.default.createElement("div", { className: "text-base text-gray-600 xl:text-center" }, copyrightContent)));
};
exports.SiteFooterSection = SiteFooterSection;
exports.default = exports.SiteFooterSection;
//# sourceMappingURL=site-footer.js.map