"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteRecordContentSection = void 0;
var react_1 = __importDefault(require("react"));
var site_submit_email_1 = require("./site-submit-email");
var lodash_1 = require("lodash");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var svg_1 = __importDefault(require("primeobjects-ui-web-basic/build/cjs/controls/svg"));
var site_title_1 = __importDefault(require("./site-title"));
var site_tags_1 = __importDefault(require("./site-tags"));
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
var SiteRecordContentSection = function (props) {
    var _a, _b, _c, _d, _e;
    var submitEmailSettings = props.submitEmailSettings, colorName = props.colorName, title = props.title, subTitle = props.subTitle, tags = props.tags, media = props.media, mediaSize = props.mediaSize, needHeaderPhoto = props.needHeaderPhoto, summary = props.summary, sourceUrl = props.sourceUrl, disableShorten = props.disableShorten, solution = props.solution;
    var titleSize = (0, lodash_1.isNil)(props.titleSize) ? "h1" : props.titleSize;
    var isExternalContent = (0, primeobjects_helper_util_1.isNonEmptyString)(sourceUrl);
    var content = isExternalContent
        ? (0, primeobjects_helper_util_1.isNonEmptyString)(summary)
            ? "<p><strong class=\"uppercase\">Summary</strong></p>".concat(summary)
            : ""
        : props.content;
    var primaryColorName = (0, primeobjects_helper_ui_1.usePrimaryColorName)();
    return (react_1.default.createElement("div", { className: "".concat((_a = props.wrapperClassName) !== null && _a !== void 0 ? _a : "", " article"), style: (_b = props.wrapperStyle) !== null && _b !== void 0 ? _b : {} },
        react_1.default.createElement(site_title_1.default, { title: title, subTitle: subTitle, titleSize: titleSize, subTitleSize: props.subTitleSize, titleClassName: props.titleClassName, titleStyle: props.titleStyle, subTitleClassName: props.subTitleClassName, subTitleStyle: (_c = props.subTitleStyle) !== null && _c !== void 0 ? _c : {} }),
        (0, primeobjects_helper_util_1.isNonEmptyString)(media) && needHeaderPhoto && (react_1.default.createElement("div", { className: "mb-6 bg-cover bg-center ".concat(mediaSize !== null && mediaSize !== void 0 ? mediaSize : "aspect aspect-w-16 aspect-h-9"), style: {
                backgroundImage: "url(".concat(media, ")")
            } })),
        react_1.default.createElement(site_tags_1.default, { disableShorten: disableShorten, data: (0, lodash_1.isArray)(tags) ? tags : [], colorName: colorName, tagClassName: "mr-4 mb-2", wrapperClassName: "mb-6 lg:hidden", onClick: props.onClickTag }),
        content && content.length > 0 ? (react_1.default.createElement("div", { className: "inline mb-2 ".concat((_d = props.contentClassName) !== null && _d !== void 0 ? _d : ""), style: (_e = props.contentStyle) !== null && _e !== void 0 ? _e : {}, dangerouslySetInnerHTML: { __html: content } })) : (react_1.default.createElement("div", { className: "inline article mb-2" },
            react_1.default.createElement("p", { className: "text-red-600" }, "There is no content or summary. *"))),
        isExternalContent && (react_1.default.createElement("div", { className: "w-full border-l-4 p-4 mt-8 md:mt-12 text-small leading-tight" },
            react_1.default.createElement("div", { className: "flex pb-3 items-center" },
                react_1.default.createElement(svg_1.default, { src: "/icons/platform/copyright.svg", size: 26 }),
                react_1.default.createElement("strong", { className: "uppercase pl-2" },
                    react_1.default.createElement("a", { href: sourceUrl, target: "_blank", className: "underline-offset-4" }, "Read Original Content"))),
            react_1.default.createElement("div", { className: "pb-2 italic" }, "The content above are summary and notes provided from a content curator. You can read the original content by clicking the link below. It will open a new browser window."),
            react_1.default.createElement("div", { className: "pb-2 italic" },
                react_1.default.createElement("a", { href: sourceUrl, target: "_black", className: "text-".concat(primaryColorName, "-600 leading-none") }, sourceUrl)),
            react_1.default.createElement("div", { className: "pb-2 italic" }, "When there's external link defined, the original content will be hidden on this page. In this case, only summary and notes will be displayed."))),
        !(0, lodash_1.isNil)(submitEmailSettings) && (react_1.default.createElement("div", { className: "text-left mt-8 md:mt-12" },
            react_1.default.createElement("div", { className: "w-full p-8 border-t-[5px] bg-".concat(colorName, "-100 border-").concat(colorName, "-400") },
                react_1.default.createElement("div", { className: "inline text-lg font-semibold text-".concat(colorName, "-700 ") }, submitEmailSettings === null || submitEmailSettings === void 0 ? void 0 : submitEmailSettings.title),
                react_1.default.createElement(site_submit_email_1.SiteSubmitEmailSection, __assign({}, submitEmailSettings, { colorName: colorName, solution: solution })))))));
};
exports.SiteRecordContentSection = SiteRecordContentSection;
exports.default = exports.SiteRecordContentSection;
//# sourceMappingURL=site-record-content.js.map