"use strict";
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SiteSubmitEmailSection = void 0;
var react_1 = __importStar(require("react"));
var core_1 = require("primeobjects-helper-util/build/cjs/core");
var util_1 = require("../util");
var recaptcha_1 = require("primeobjects-ui-web-basic/build/cjs/controls/recaptcha");
var lodash_1 = require("lodash");
var primeobjects_helper_ui_1 = require("primeobjects-helper-ui");
var SiteSubmitEmailSection = function (props) {
    var _a, _b;
    var recaptchaId = props.recaptchaId, emailTemplate = props.emailTemplate, hideRecaptcha = props.hideRecaptcha, signUp = props.signUp;
    var solution = props.solution ? props.solution : (0, primeobjects_helper_ui_1.getSolution)();
    var wrapperClassName = (0, core_1.isNonEmptyString)(props.wrapperClassName)
        ? props.wrapperClassName
        : "";
    var primaryColorName = (0, primeobjects_helper_ui_1.usePrimaryColorName)(solution);
    var colorName = props.colorName ? props.colorName : primaryColorName;
    var apiEndpoint = props.apiEndpoint
        ? props.apiEndpoint
        : (0, util_1.getApiEndpoint)(solution, "subscription", "subscribe");
    // const apiEndpoint = "http://localhost:3000/prod/subscribe";
    var _c = (0, react_1.useState)(""), email = _c[0], setEmail = _c[1];
    var _d = (0, react_1.useState)(""), error = _d[0], setError = _d[1];
    var _e = (0, react_1.useState)(""), success = _e[0], setSuccess = _e[1];
    var _f = (0, react_1.useState)(""), doing = _f[0], setDoing = _f[1];
    var _g = (0, react_1.useState)(false), showRecaptcha = _g[0], setShowRecaptcha = _g[1];
    var contactEmail = props.contactEmail && (0, core_1.isNonEmptyString)(props.contactEmail)
        ? props.contactEmail
        : "sky";
    var thankYouMessage = props.thankYouMessage && (0, core_1.isNonEmptyString)(props.thankYouMessage)
        ? props.thankYouMessage
        : "Thank you, you email has been submitted successfully.";
    var errorMessage = props.errorMessage && (0, core_1.isNonEmptyString)(props.errorMessage)
        ? props.errorMessage
        : "Sorry, we can not submit your request at the moment, please try again later".concat(contactEmail.length > 0 ? " or email to ".concat(contactEmail) : "", ".");
    var buttonText = props.buttonText && (0, core_1.isNonEmptyString)(props.buttonText)
        ? props.buttonText
        : "Submit";
    var privacyPolicyUrl = (_b = (_a = props.privacyPolicyUrl) !== null && _a !== void 0 ? _a : solution.privacyPolicyUrl) !== null && _b !== void 0 ? _b : "/read/privacy-policy";
    var apiData = props.apiData ? props.apiData : {};
    var recaptchaSiteKey = hideRecaptcha
        ? ""
        : props.recaptchaSiteKey
            ? props.recaptchaSiteKey
            : solution.keys.recaptchaSiteKey;
    if (!apiData.regardingId)
        apiData.regardingId = recaptchaId;
    if (!apiData.emailTemplate)
        apiData.emailTemplate = emailTemplate;
    if (!(0, lodash_1.isNil)(apiData.signUp))
        apiData.signUp = signUp;
    (0, react_1.useEffect)(function () {
        if (!(0, core_1.isNonEmptyString)(apiEndpoint)) {
            setError("Please provide apiEndpoint!");
        }
    }, [apiEndpoint]);
    var onChangeEmail = function (e) {
        var text = e.target.value;
        if ((0, core_1.isEmail)(text) && !showRecaptcha) {
            setSuccess("");
            setShowRecaptcha(true);
        }
        setEmail(text);
    };
    var onSubmit = function () {
        if (!(0, core_1.isEmail)(email)) {
            setError("Please provide a valid email address.");
            return;
        }
        if (props.onSubmit)
            return props.onSubmit(email);
        var recaptchaToken = (0, recaptcha_1.getRecaptchaToken)(recaptchaId);
        if (!(0, core_1.isNonEmptyString)(recaptchaToken)) {
            setError("Are you a robot? Please finish reCAPTCHA check.");
            return;
        }
        setDoing("Submitting ...");
        setError("");
        (0, util_1.callApiBase)(apiEndpoint, __assign(__assign({}, apiData), { email: email, recaptchaToken: recaptchaToken }), "POST", {
            solutionId: solution.id
        })
            .then(function (result) {
            setShowRecaptcha(false);
            setEmail("");
            setSuccess(thankYouMessage);
            if ((0, lodash_1.isFunction)(props.onSuccess))
                props.onSuccess(result);
        })
            .catch(function (error) {
            setError(errorMessage);
            if ((0, lodash_1.isFunction)(props.onError))
                props.onError(error);
        })
            .finally(function () {
            setDoing("");
        });
    };
    var onClickRecaptcha = function () {
        setError("");
    };
    return (react_1.default.createElement("div", { className: "".concat(wrapperClassName) },
        showRecaptcha && (0, core_1.isNonEmptyString)(recaptchaSiteKey) && (react_1.default.createElement("div", { className: "w-full flex my-2", onClick: onClickRecaptcha },
            react_1.default.createElement(recaptcha_1.Recaptcha, { id: recaptchaId, siteKey: recaptchaSiteKey }))),
        (0, core_1.isNonEmptyString)(apiEndpoint) && (react_1.default.createElement("div", { className: "mt-3 w-full flex flex-col sm:flex-row", style: { maxWidth: 500 } },
            react_1.default.createElement("div", { className: "min-w-0 flex-1" },
                react_1.default.createElement("div", { className: "w-full", style: { minWidth: 302 } },
                    react_1.default.createElement("input", { onChange: onChangeEmail, value: email, type: "email", className: "block w-full border border-gray-300 rounded-md p-3 text-base text-gray-900 placeholder-gray-500 shadow-sm focus:border-".concat(colorName, "-500 focus:ring-").concat(colorName, "-500"), placeholder: "Enter your email" }))),
            react_1.default.createElement("div", { className: "mt-2 ml-0 sm:mt-0 sm:ml-3" },
                react_1.default.createElement("button", { disabled: (0, core_1.isNonEmptyString)(doing), onClick: onSubmit, type: "submit", className: "block w-full h-full rounded-md ".concat((0, core_1.isNonEmptyString)(doing)
                        ? "cursor-not-allowed"
                        : "cursor-pointer", " border border-transparent px-5 py-2 bg-").concat(colorName, "-600 text-lg font-medium text-white shadow hover:bg-").concat(colorName, "-700 focus:outline-none focus:ring-2 focus:ring-").concat(colorName, "-700 focus:ring-offset-2 sm:px-10") }, (0, core_1.isNonEmptyString)(doing) ? doing : buttonText)))),
        (0, core_1.isNonEmptyString)(error) && (react_1.default.createElement("div", { className: "mt-4 w-full flex text-red-700", style: { maxWidth: 460 } }, error)),
        (0, core_1.isNonEmptyString)(success) && (react_1.default.createElement("div", { className: "mt-4 w-full flex text-green-700", style: { maxWidth: 460 } }, success)),
        react_1.default.createElement("div", { className: "mt-6" },
            react_1.default.createElement("p", { className: "mt-3 text-sm text-gray-600" },
                "We care about the protection of your data. Read our ",
                react_1.default.createElement("a", { target: "_blank", href: privacyPolicyUrl, className: "font-medium underline" }, "Privacy Policy"),
                "."))));
};
exports.SiteSubmitEmailSection = SiteSubmitEmailSection;
exports.default = exports.SiteSubmitEmailSection;
//# sourceMappingURL=site-submit-email.js.map