import { Method } from "axios";
export type TNotificationType = "success" | "info" | "warning" | "error" | "close";
export type TNotification = {
    refresh: string | number;
    type: TNotificationType;
    message?: string;
};
export type TApiSettings = {
    apiToken?: string;
    recordToken?: string;
    headers?: Record<string, any>;
    solutionId?: string;
    callerId?: string;
    stage?: "dev" | "staging" | "prod";
    abortSignal?: any;
};
export declare const getApiEndpointBase: (apis: Record<string, any>, apiName: string, functionName: string) => string | undefined;
export declare const getApiEndpoint: (solution: Record<string, any>, apiName: string, functionName: string, entityName?: string) => string;
export declare const setGlobalApiEndpoint: (solutionId: string, apiName: string, functionName: string, value: string, entityName?: string) => void;
export declare const getGlobalApiEndpoint: (solutionId: string, apiName: string, functionName: string, entityName?: string) => any;
export declare const getApiRootError: (error: Record<string, any>) => any;
export declare const callApiBase: (url: string, data: Record<string, any>, method: Method, settings?: TApiSettings) => Promise<Record<string, any>>;
export declare const uploadToS3: (url: string, fileName: string, data: any) => Promise<import("axios").AxiosResponse<any, any>>;
export declare const setGlobalComponent: (name: string, component: any) => void;
export declare const getGlobalComponent: (name: string, defaultComponent?: any) => any;
