//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
import React from "react";
import Lottie from "primeobjects-ui-web-basic/build/cjs/controls/lottie";
import { isNonEmptyString } from "primeobjects-helper-util/build/cjs/core";
import { GRAY } from "primeobjects-helper-util";
import SVG from "primeobjects-ui-web-basic/build/cjs/controls/svg";
export var InProgress = function (props) {
    var _a, _b, _c, _d;
    var text = props.text;
    var color = (_a = props.color) !== null && _a !== void 0 ? _a : GRAY;
    var type = (_b = props.type) !== null && _b !== void 0 ? _b : "lottie";
    return (React.createElement("div", { className: "flex flex-row w-full items-center ".concat((_c = props.className) !== null && _c !== void 0 ? _c : ""), style: (_d = props.style) !== null && _d !== void 0 ? _d : {} },
        React.createElement("div", { className: "h-10 flex items-center" }, type == "lottie" ? (React.createElement(Lottie, { className: "w-full h-full", url: "/icons/platform/lottie/dots-2.json", colors: Array(6).fill(color[500]) })) : (React.createElement(SVG, { src: "/icons/platform/loading.svg", className: "spinner", color: color[500], style: { width: 20, height: 20 } }))),
        isNonEmptyString(text) && (React.createElement("div", { className: "flex-1 text-base text-".concat(color.name, "-500 p-2") }, text))));
};
export default InProgress;
//# sourceMappingURL=in-progress.js.map