var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
//  COPYRIGHT:       PrimeObjects Software Inc. (C) 2022 All Right Reserved
//  COMPANY URL:     https://www.primeobjects.com/
//  CONTACT:         developer@primeobjects.com
//
//  This source is subject to the PrimeObjects License Agreements.
import { getWindow, isNonEmptyString, isObject, libTrackIsOn, isObjectString, getGlobalObject } from "primeobjects-helper-util/build/cjs/core";
import { getWebLocation } from "primeobjects-helper-util/build/cjs/web";
import { getContentType } from "primeobjects-helper-util/build/cjs/file";
import { isNil, isEmpty } from "lodash";
import axios from "axios";
import { getSolution } from "primeobjects-helper-ui";
import { getEntity } from "primeobjects-helper-util";
var processServerlessOfflineError = function (exception) {
    if (isObject(exception) && isObject(exception.request)) {
        var response = exception.request.response;
        try {
            return JSON.parse(JSON.parse(JSON.parse(response).errorMessage).body);
        }
        catch (e) { }
    }
    return {};
};
export var getApiEndpointBase = function (apis, apiName, functionName) {
    if (isNonEmptyString(apis && apis["".concat(apiName, "-").concat(functionName)])) {
        return apis["".concat(apiName, "-").concat(functionName)];
    }
    if (isNonEmptyString(apis && apis[apiName])) {
        return "".concat(apis[apiName]).concat(functionName);
    }
    return undefined;
};
export var getApiEndpoint = function (solution, apiName, functionName, entityName) {
    var globalApi = getGlobalApiEndpoint(solution.id, apiName, functionName, entityName);
    if (isNonEmptyString(globalApi))
        return globalApi;
    if (entityName) {
        var entity = getEntity(solution, entityName);
        var entityLevelEndpoint = getApiEndpointBase(entity && entity.apis, apiName, functionName);
        if (entityLevelEndpoint)
            return entityLevelEndpoint;
    }
    var solutionLevelEndpoint = getApiEndpointBase(solution.apis, apiName, functionName);
    if (solutionLevelEndpoint) {
        return solutionLevelEndpoint;
    }
    return "";
};
export var setGlobalApiEndpoint = function (solutionId, apiName, functionName, value, entityName) {
    var key = "".concat(solutionId, "-").concat(apiName, "-").concat(functionName, "-").concat(entityName);
    if (!getGlobalObject()._apis) {
        getGlobalObject()._apis = {};
    }
    getGlobalObject()._apis[key] = value;
};
export var getGlobalApiEndpoint = function (solutionId, apiName, functionName, entityName) {
    var key = "".concat(solutionId, "-").concat(apiName, "-").concat(functionName, "-").concat(entityName);
    var apis = getGlobalObject()._apis;
    if (apis) {
        return apis[key];
    }
    return undefined;
};
export var getApiRootError = function (error) {
    if (isNil(error) || !(error === null || error === void 0 ? void 0 : error.error) || (error === null || error === void 0 ? void 0 : error.statusCode))
        return error;
    return getApiRootError(error.error);
};
export var callApiBase = function (url, data, method, settings) {
    if (!isObject(settings))
        settings = {};
    if (isNil(data))
        data = {};
    var window = getWindow();
    var headers = __assign(__assign({}, settings === null || settings === void 0 ? void 0 : settings.headers), { Accept: "application/json,application/xml,text/plain,text/html,*.*" });
    if (settings === null || settings === void 0 ? void 0 : settings.solutionId) {
        headers.solutionId = settings.solutionId;
    }
    else {
        headers.solutionId = getSolution().solutionId;
    }
    if (isNonEmptyString(settings === null || settings === void 0 ? void 0 : settings.apiToken)) {
        headers.apiToken = settings === null || settings === void 0 ? void 0 : settings.apiToken;
    }
    if (isNonEmptyString(settings === null || settings === void 0 ? void 0 : settings.recordToken)) {
        headers.recordToken = settings === null || settings === void 0 ? void 0 : settings.recordToken;
    }
    if (isNonEmptyString(settings === null || settings === void 0 ? void 0 : settings.callerId)) {
        headers.callerId = settings === null || settings === void 0 ? void 0 : settings.callerId;
    }
    var webL = getWebLocation("".concat(window.location));
    if (webL && webL.host) {
        var port = !isNonEmptyString(webL.port) || webL.port == "80"
            ? ""
            : ":".concat(webL.port);
        headers.domain = "".concat(webL.host).concat(port);
    }
    var config = {
        url: url,
        method: method,
        headers: headers,
        signal: settings === null || settings === void 0 ? void 0 : settings.abortSignal
    };
    if (method.toUpperCase() === "GET") {
        if (isObject(data))
            config.params = data;
    }
    else {
        if (isObject(data))
            config.data = data;
    }
    return new Promise(function (resolve, reject) {
        var localApi = url.indexOf("//localhost") > 0;
        axios(config)
            .then(function (result) {
            if (libTrackIsOn())
                console.log({ callApiBaseResult: result });
            var data = result.data;
            var body = {};
            if (isNonEmptyString(data === null || data === void 0 ? void 0 : data.body)) {
                try {
                    body = JSON.parse(data === null || data === void 0 ? void 0 : data.body);
                    resolve(body);
                }
                catch (_a) {
                    body = {};
                }
            }
            if (isObject(data) && (data.errorType || data.errorMessage)) {
                throw data;
            }
            if (isObject(data) && data.type == "error") {
                throw data;
            }
            if (isObject(data) && isObject(data.error)) {
                throw data.error;
            }
            if (isObject(data) && data.statusCode === 200) {
                data = data.body;
            }
            // console.log({ data})
            resolve(data);
        })
            .catch(function (exception) {
            var _a, _b, _c, _d;
            var error = {};
            if (localApi) {
                error = processServerlessOfflineError(exception);
            }
            if (isEmpty(error)) {
                if (isObjectString((_b = (_a = exception === null || exception === void 0 ? void 0 : exception.response) === null || _a === void 0 ? void 0 : _a.data) === null || _b === void 0 ? void 0 : _b.body)) {
                    error = JSON.parse((_d = (_c = exception === null || exception === void 0 ? void 0 : exception.response) === null || _c === void 0 ? void 0 : _c.data) === null || _d === void 0 ? void 0 : _d.body);
                }
                else {
                    error.message = exception.message;
                    error.code = 500;
                }
            }
            if (error.message && !error.statusMessage)
                error.statusMessage = error.message;
            if (error.name && !error.statusName)
                error.statusName = error.name;
            if (error.code && !error.statusCode)
                error.statusCode = error.code;
            if (error.message != "canceled") {
                console.error({ exception: exception });
                console.error({ error: error });
            }
            reject(error);
        })
            .finally(function () { });
    });
};
export var uploadToS3 = function (url, fileName, data) { return __awaiter(void 0, void 0, void 0, function () {
    var config, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                config = {
                    url: url,
                    method: "put",
                    headers: {
                        "Content-Type": getContentType(fileName)
                    },
                    data: data
                };
                return [4 /*yield*/, axios.request(config)];
            case 1: return [2 /*return*/, _a.sent()];
            case 2:
                err_1 = _a.sent();
                console.error(err_1);
                throw new Error("API request failed. check console");
            case 3: return [2 /*return*/];
        }
    });
}); };
export var setGlobalComponent = function (name, component) {
    if (!getGlobalObject()._components) {
        getGlobalObject()._components = {};
    }
    getGlobalObject()._components[name] = component;
};
export var getGlobalComponent = function (name, defaultComponent) {
    var components = getGlobalObject()._components;
    var component = defaultComponent;
    if (components) {
        component = components[name];
    }
    return component ? component : defaultComponent;
};
//# sourceMappingURL=util.js.map